% Parametri del sistema del primo ordine
%            1-p1    z-z1
% G(z) = mu*----- * -------
%            1-z1    p-p1      
z1 = 0.2;
p1 = 0.5;
mu = 1;
% Tempo di campionamento
T = 1;

% Sistema
sys = mu*(1-p1)/(1-z1)*tf([1 -z1],[1 -p1],T);


% Risposta al gradino
k = 0:1:10;
y = mu*(1-p1.^k)+mu*(1-p1)/(1-z1)*p1.^k;

% Risposta all'impulso w(k) = h(k)-h(k-1)
y_i = diff(y);

% Coefficienti del filtro FIR
coeffFIR = y_i(find(y_i>=1e-3));

% Filtro FIR
sys_FIR = tf(coeffFIR,[1 zeros(1,length(coeffFIR)-1)],T);
% Moltiplicazione per un guadagno affinch sia G(1)=G_{FIR}(1)
sys_FIR = dcgain(sys)/dcgain(sys_FIR)*sys_FIR;

% Plot
step(sys,'-or',sys_FIR,'-*b')
legend({'Sistema','FIR approssimato'})
